/* USER CODE BEGIN Header */
/**
 ******************************************************************************
 * @file           : main.c
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * Copyright (c) 2023 STMicroelectronics.
 * All rights reserved.
 *
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 * If no LICENSE file comes with this software, it is provided AS-IS.
 *
 ******************************************************************************
 */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "dma.h"
#include "i2c.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ssd1306.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
#define GpsRxBuf_SIZE 512
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
uint8_t GpsRxBuf[GpsRxBuf_SIZE];
volatile uint8_t gps_data_received_flag = 0;
volatile uint8_t gps_data_ok_flag = 0;
extern DMA_HandleTypeDef hdma_usart1_rx;
float latitude;
float longitude;

uint8_t UartMessage[64];
uint8_t UartMessageLength;

char lcd_line[32];

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

void ParseGpsData(void);

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
 * @brief  The application entry point.
 * @retval int
 */
int main(void)
{
	/* USER CODE BEGIN 1 */

	/* USER CODE END 1 */

	/* MCU Configuration--------------------------------------------------------*/

	/* Reset of all peripherals, Initializes the Flash interface and the Systick. */
	HAL_Init();

	/* USER CODE BEGIN Init */

	/* USER CODE END Init */

	/* Configure the system clock */
	SystemClock_Config();

	/* USER CODE BEGIN SysInit */

	/* USER CODE END SysInit */

	/* Initialize all configured peripherals */
	MX_GPIO_Init();
	MX_DMA_Init();
	MX_USART2_UART_Init();
	MX_USART1_UART_Init();
	MX_I2C1_Init();
	/* USER CODE BEGIN 2 */

	ssd1306_Init();

	HAL_UARTEx_ReceiveToIdle_DMA(&huart1, GpsRxBuf, GpsRxBuf_SIZE);
	__HAL_DMA_DISABLE_IT(&hdma_usart1_rx, DMA_IT_HT);

	UartMessageLength = sprintf((char*) UartMessage, "\033[2J\033[;H"); // Clear terminal and home cursor
	HAL_UART_Transmit(&huart2, UartMessage, UartMessageLength, 1000);
	/* USER CODE END 2 */

	/* Infinite loop */
	/* USER CODE BEGIN WHILE */
	while (1)
	{
		if (gps_data_received_flag == 1)
		{
			gps_data_received_flag = 0;

			ParseGpsData();
			if (gps_data_ok_flag == 1)
			{
				HAL_UARTEx_ReceiveToIdle_DMA(&huart1, GpsRxBuf, GpsRxBuf_SIZE);
				__HAL_DMA_DISABLE_IT(&hdma_usart1_rx, DMA_IT_HT);

//				UartMessageLength = sprintf((char*) UartMessage,
//						"\033[2J\033[;H"); // Clear terminal and home cursor
//				HAL_UART_Transmit(&huart2, UartMessage, UartMessageLength,
//						1000);
				UartMessageLength = sprintf((char*) UartMessage,
						"Latitude:   %.6f\n\r", latitude / 100);
				HAL_UART_Transmit(&huart2, UartMessage, UartMessageLength,
						1000);
				UartMessageLength = sprintf((char*) UartMessage,
						"Longitude:  %.6f\n\r", longitude / 100);
				HAL_UART_Transmit(&huart2, UartMessage, UartMessageLength,
						1000);

				ssd1306_Fill(Black);
				ssd1306_SetCursor(20, 0);
				ssd1306_WriteString("ufnalski.edu.pl", Font_6x8, White);
				ssd1306_SetCursor(15, 11);
				ssd1306_WriteString("NEO-6M DMA demo", Font_6x8, White);
				sprintf(lcd_line, "Lat.:  %.6f", latitude / 100);
				ssd1306_SetCursor(2, 35);
				ssd1306_WriteString(lcd_line, Font_6x8, White);
				sprintf(lcd_line, "Long.: %.6f", longitude / 100);
				ssd1306_SetCursor(2, 50);
				ssd1306_WriteString(lcd_line, Font_6x8, White);
				ssd1306_UpdateScreen();
			}
			else
			{
//				UartMessageLength = sprintf((char*) UartMessage,
//						"\033[2J\033[;H"); // Clear terminal and home cursor
//				HAL_UART_Transmit(&huart2, UartMessage, UartMessageLength,
//						1000);
				UartMessageLength = sprintf((char*) UartMessage,
						"No valid data.");
				HAL_UART_Transmit(&huart2, UartMessage, UartMessageLength,
						1000);

				ssd1306_Fill(Black);
				sprintf(lcd_line, "No valid data!       ");
				ssd1306_SetCursor(2, 35);
				ssd1306_WriteString(lcd_line, Font_6x8, White);
				ssd1306_UpdateScreen();
			}

		}
		/* USER CODE END WHILE */

		/* USER CODE BEGIN 3 */
	}
	/* USER CODE END 3 */
}

/**
 * @brief System Clock Configuration
 * @retval None
 */
void SystemClock_Config(void)
{
	RCC_OscInitTypeDef RCC_OscInitStruct =
	{ 0 };
	RCC_ClkInitTypeDef RCC_ClkInitStruct =
	{ 0 };

	/** Configure the main internal regulator output voltage
	 */
	if (HAL_PWREx_ControlVoltageScaling(PWR_REGULATOR_VOLTAGE_SCALE1) != HAL_OK)
	{
		Error_Handler();
	}

	/** Configure LSE Drive Capability
	 */
	HAL_PWR_EnableBkUpAccess();
	__HAL_RCC_LSEDRIVE_CONFIG(RCC_LSEDRIVE_LOW);

	/** Initializes the RCC Oscillators according to the specified parameters
	 * in the RCC_OscInitTypeDef structure.
	 */
	RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_LSE
			| RCC_OSCILLATORTYPE_MSI;
	RCC_OscInitStruct.LSEState = RCC_LSE_ON;
	RCC_OscInitStruct.MSIState = RCC_MSI_ON;
	RCC_OscInitStruct.MSICalibrationValue = 0;
	RCC_OscInitStruct.MSIClockRange = RCC_MSIRANGE_6;
	RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
	RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_MSI;
	RCC_OscInitStruct.PLL.PLLM = 1;
	RCC_OscInitStruct.PLL.PLLN = 40;
	RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV7;
	RCC_OscInitStruct.PLL.PLLQ = RCC_PLLQ_DIV2;
	RCC_OscInitStruct.PLL.PLLR = RCC_PLLR_DIV2;
	if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
	{
		Error_Handler();
	}

	/** Initializes the CPU, AHB and APB buses clocks
	 */
	RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK | RCC_CLOCKTYPE_SYSCLK
			| RCC_CLOCKTYPE_PCLK1 | RCC_CLOCKTYPE_PCLK2;
	RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
	RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
	RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;
	RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

	if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_4) != HAL_OK)
	{
		Error_Handler();
	}

	/** Enable MSI Auto calibration
	 */
	HAL_RCCEx_EnableMSIPLLMode();
}

/* USER CODE BEGIN 4 */
void HAL_UARTEx_RxEventCallback(UART_HandleTypeDef *huart, uint16_t Size)
{
	if (huart->Instance == USART1)
	{
		gps_data_received_flag = 1;
	}
}

void ParseGpsData(void)
{
	// https://www.rfwireless-world.com/Terminology/GPS-sentences-or-NMEA-sentences.html
	uint16_t inx = 0;
	uint8_t buff[16];
	if ((GpsRxBuf[0] == '$') && (GpsRxBuf[1] == 'G') && (GpsRxBuf[2] == 'P')
			&& (GpsRxBuf[3] == 'R') && (GpsRxBuf[4] == 'M')
			&& (GpsRxBuf[5] == 'C'))
	{
		// $GPRMC
		inx = 7;
		while (GpsRxBuf[inx] != ',')
		{
			inx++;
		}  // UTC time
		inx++;
		if (GpsRxBuf[inx] == 'A') // Status (A = valid data)
		{
			inx++;
			inx++;
			uint8_t inx_latitude = 0;
			while (GpsRxBuf[inx] != ',')
			{
				buff[inx_latitude] = GpsRxBuf[inx];
				inx_latitude++;
				inx++;
			}
			buff[inx_latitude] = '\0';
			latitude = atoff((char*) buff);
			inx++;
			inx++;
			inx++;
			uint8_t inx_longitude = 0;
			while (GpsRxBuf[inx] != ',')
			{
				buff[inx_longitude] = GpsRxBuf[inx];
				inx_longitude++;
				inx++;
			}
			buff[inx_longitude] = '\0';
			longitude = atoff((char*) buff);
			gps_data_ok_flag = 1;
		}
		else
		{
			gps_data_ok_flag = 0;
			HAL_UARTEx_ReceiveToIdle_DMA(&huart1, GpsRxBuf, GpsRxBuf_SIZE);
			__HAL_DMA_DISABLE_IT(&hdma_usart1_rx, DMA_IT_HT);
		}
	}
	else
	{
		gps_data_ok_flag = 0;
		HAL_UARTEx_ReceiveToIdle_DMA(&huart1, GpsRxBuf, GpsRxBuf_SIZE);
		__HAL_DMA_DISABLE_IT(&hdma_usart1_rx, DMA_IT_HT);
	}
}
/* USER CODE END 4 */

/**
 * @brief  This function is executed in case of error occurrence.
 * @retval None
 */
void Error_Handler(void)
{
	/* USER CODE BEGIN Error_Handler_Debug */
	/* User can add his own implementation to report the HAL error return state */
	__disable_irq();
	while (1)
	{
	}
	/* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
